<?php
/*********************************************************************\
| (c)2013 rebelion76                                                  |
| (c)2014-2015 Synoboost                   http://www.synoboost.com   |
|---------------------------------------------------------------------|
| This program is free software; you can redistribute it and/or       |
| modify it under the terms of the GNU General Public License         |
| as published by the Free Software Foundation; either version 2      |
| of the License, or (at your option) any later version.              |
|                                                                     |
| This program is distributed in the hope that it will be useful,     |
| but WITHOUT ANY WARRANTY; without even the implied warranty of      |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       |
| GNU General Public License for more details.                        |
|                                                                     |
| You should have received a copy of the GNU General Public License   |
| along with this program; If not, see <http://www.gnu.org/licenses/> |
\*********************************************************************/
?>
<?php

class SynoDLMProxykinozaltv
{
        //   
        const USER_LOGIN = ' ';
        //   
        const USER_PASSWORD  = ' ';
        //    action   
        const LOGIN_URL = 'http://kinozal.tv/takelogin.php';
        //        
        const LOGIN_NAME = 'username'; 
        //        
        const PASSWORD_NAME = 'password'; 
        //                                    
        const INFO_URL = 'http://kinozal.tv/details.php?id=%s';
        //     
        const TORRENT_URL = 'http://kinozal.tv/download.php?id=%1$s.torrent';
        //     -  
        const TORRENT_REGEXP = "/<a href=\"\/download\.php\/(.*)\.torrent\"/siU";
        //  ,         
        const EMPTY_PAGE_REGEXP ='/  /';
        //     
        const TORRENTS_LIST_URL = 'http://kinozal.tv/browse.php?s=%s&page=%s';
        //       
        const MAX_TORRENTS_PAGE=39;

        
        //  curl
        private $curl_descr;
        
        //     curl
        private $curl_options_array = array 
                (
                        CURLOPT_HTTPHEADER => array 
                        (                       
                                'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*;q=0.8',
                                'Accept-Language: ru,en-us;q=0.7,en;q=0.3',
                                'Accept-Encoding: deflate',
                                'Accept-Charset: windows-1251,utf-8;q=0.7,*;q=0.7'
                        ),                      
                        CURLOPT_FAILONERROR => 1,
                        CURLOPT_FOLLOWLOCATION => 1,
                        CURLOPT_RETURNTRANSFER => 1,
                        CURLOPT_TIMEOUT => 30,
                        CURLOPT_USERAGENT => 'Mozilla/5.0 (Windows; U; Windows NT 5.1; ru; rv:1.9.0.4) Gecko/2008102920 Firefox/5.0.1',
                        CURLOPT_COOKIEFILE => 'cookie.txt',
                        CURLOPT_COOKIEJAR => 'cookie.txt' 
                );
        //  singleton
        protected static $instance = null;
        
        private function __construct()
        { 
                //   
                $this->curl_descr = curl_init();
                
                curl_setopt_array($this->curl_descr,$this->curl_options_array);

                //     post   
                curl_setopt($this->curl_descr, CURLOPT_URL, self::LOGIN_URL);
                curl_setopt($this->curl_descr, CURLOPT_POST, 1);
                curl_setopt($this->curl_descr, CURLOPT_POSTFIELDS, self::LOGIN_NAME.'='.self::USER_LOGIN.'&'.self::PASSWORD_NAME."=".self::USER_PASSWORD);

                curl_exec($this->curl_descr);
        }
        private function __clone() { }
        
        public static function get_instance() 
        {
                if (self::$instance === null) 
                {
                       self::$instance = new self();
                }    
                return self::$instance;
        }        
               
        
        //  -   id
        public function get_torrent_file ($torrent_id) 
        {
               
                //    -file  
                $torrent_url=sprintf(self::TORRENT_URL,$torrent_id);
                
                //                          
                curl_setopt($this->curl_descr, CURLOPT_POST, 1);
                curl_setopt($this->curl_descr, CURLOPT_URL, $torrent_url);
                curl_setopt($this->curl_descr, CURLOPT_BINARYTRANSFER, 1);
                $response = curl_exec($this->curl_descr);
  
                curl_close($this->curl_descr);
                
                return $response;
        }
        //        ,    
        public function get_torrents_list ($torrents_query)
        {       
                //   
                $is_lastpage=0;
                //  
                $i=0;
                //    
                $result="";
                $response="";
                                  
                do
                {
                        //  
                        $result=$result.$response;

                        //   
                        curl_setopt($this->curl_descr, CURLOPT_POST, 0);
                        curl_setopt($this->curl_descr, CURLOPT_URL, sprintf(self::TORRENTS_LIST_URL,$torrents_query,$i));
                        curl_exec($this->curl_descr);
                        $response = curl_exec($this->curl_descr);

                        //    
                        $is_lastpage=preg_match(self::EMPTY_PAGE_REGEXP,$response);

                        $i++;
                }
                while ( !$is_lastpage AND ($i<=self::MAX_TORRENTS_PAGE)) ;

                curl_close($this->curl_descr);

                return  $result;
        }
}

$proxy_class = SynoDLMProxykinozaltv::get_instance();

switch ($_GET['method_type']) 
{
        case  'file':  
             
                if (!is_numeric($_GET['torrent_id'])) 
                { 
                    //-   
                    break;
                }
                //  -
                $torrent_file = $proxy_class->get_torrent_file($_GET['torrent_id']);

                //  -  
                header('Content-Type: application/x-bittorrent');
                header('Content-Disposition: attachment; filename="'.$_GET['torrent_id'].'.torrent"');
                echo $torrent_file;
                break;
        case  'list':  //   
                $torrents_query = urlencode($_GET['torrents_query']);

                //    
                echo $proxy_class->get_torrents_list($torrents_query);
                break;
        default: 
                // - 
}

?>
