<?php
class SynoDLMSearchNGRuTracker {
        private $wurl = 'http://localhost/ds/rutracker.org/';      // Web address where Web part located
        private $qurl = 'prepare.php?query=%s';
        private $turl = 'torrent.php?id=%s';
        private $purl = 'http://rutracker.org/forum/';

        public function __construct() {
                $this->qurl=$this->wurl.$this->qurl;
                $this->turl=$this->wurl.$this->turl;
        }

        public function prepare($curl, $query) {
                $url = $this->qurl;
                curl_setopt($curl, CURLOPT_URL, sprintf($url, urlencode($query)));
        }

        public function parse($plugin, $response) {
                $input = iconv("cp1251","UTF-8",$response);

                $regexp2 = "<tr class=\"tCenter hl-tr\">(.*)<\/tr>";
                $regexp_category = "<td.*tracker.php\?f=([0-9]+)\">(.*)<\/a><\/td>";
                $regexp_title = "<td.*(viewtopic.php\?t=[0-9]+)\">(.*)<\/a>";
                $regexp_download = "dl.php?\?t=([0-9]+)\"";
                $regexp_size = "tor-size\">.*<u>([0-9]+)<\/u>";
                $regexp_datetime = "2px;\">.*<u>([0-9]+)<\/u>";
                $regexp_seeds = "<b class=\"seedmed\">([0-9]+)<";
                $regexp_leechs = "<td.*\"row4 leechmed\".*([0-9]+)<";
                
                $res=0;
                if(preg_match_all("/$regexp2/siU", $input, $matches2, PREG_SET_ORDER)) {
                        foreach($matches2 as $match2) {
                                $title="Unknown title";
                                $download="Unknown download";
                                $size=0;
                                $datetime="1978-09-28";
                                $page="Default page";
                                $hash="Hash unknown";
                                $seeds=0; 
                                $leechs=0;
                                $category="Unknown category";                                                                

                                if(preg_match_all("/$regexp_category/siU", $match2[0], $matches, PREG_SET_ORDER)) {
                                        foreach($matches as $match) {
                                                $category =  $match[2];
                                        }
                                }

                                if(preg_match_all("/$regexp_title/siU", $match2[0], $matches, PREG_SET_ORDER)) {
                                        foreach($matches as $match) {
                                                $page = $this->purl.$match[1];
                                                $title =  str_replace("<wbr>","",$match[2]);
                                                $hash = md5($res.$title);
                                        }
                                }

                                if(preg_match_all("/$regexp_download/siU", $match2[0], $matches, PREG_SET_ORDER)) {
                                        foreach($matches as $match) {
                                                $download = sprintf($this->turl, $match[1]);
                                        }
                                }

                                if(preg_match_all("/$regexp_size/siU", $match2[0], $matches, PREG_SET_ORDER)) {
                                        foreach($matches as $match) {
                                                $size = $match[1];
                                        }
                                }

                                if(preg_match_all("/$regexp_datetime/siU", $match2[0], $matches, PREG_SET_ORDER)) {
                                        foreach($matches as $match) {
                                                $datetime = date('Y-m-d H:i',$match[1]);
                                        }
                                }

                                if(preg_match_all("/$regexp_seeds/siU", $match2[0], $matches, PREG_SET_ORDER)) {
                                        foreach($matches as $match) {
                                                $seeds = $match[1];
                                        }
                                }

                                if(preg_match_all("/$regexp_leechs/siU", $match2[0], $matches, PREG_SET_ORDER)) {
                                        foreach($matches as $match) {
                                                $leechs = $match[1];
                                        }
                                }

                                if ($title!="Unknown title") {
                                        $plugin->addResult($title, $download, $size, $datetime, $page, $hash, $seeds, $leechs, $category);
                                        $res++;
                                }
                        }
                }

                return $res;       
        }
}
?>