<?php
/*********************************************************************\
| (c)2013 rebelion76                                                  |
| (c)2014 Synoboost                        http://www.synoboost.com   |
|---------------------------------------------------------------------|
| This program is free software; you can redistribute it and/or       |
| modify it under the terms of the GNU General Public License         |
| as published by the Free Software Foundation; either version 2      |
| of the License, or (at your option) any later version.              |
|                                                                     |
| This program is distributed in the hope that it will be useful,     |
| but WITHOUT ANY WARRANTY; without even the implied warranty of      |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       |
| GNU General Public License for more details.                        |
|                                                                     |
| You should have received a copy of the GNU General Public License   |
| along with this program; If not, see <http://www.gnu.org/licenses/> |
\*********************************************************************/
?>
<?php
class SynoDLMSearchkinozaltv 
{
        //    
        //    ,      -    
        const PROXY_URL = 'http://localhost/ds/kinozal.tv/';
        //      
        const QUERY_URL = 'proxy.php?method_type=list&torrents_query=%s'; 
        //   -
        const TORRENT_URL = 'proxy.php?method_type=file&torrent_id=%s'; 
        //       
        const INFO_URL = 'http://kinozal.tv/details.php?id=%s';
        //               
        const TORRENTS_REGEXP = '/<tr.*?><td class="bt"><img.*?onclick="cat\(([0-9]+)\);".*?>(.*?)<\/tr>/s'; 
        //      
//V1.1        const TORRENT_PARAMS_REGEXP = '/<td class=\"nam\"><a href=\"\/details\.php\?id=([0-9]+)\" class=\"(.*?)\">(.*?)<\/a><td class=\'s\'>.*?<\/td>.*?<td class=\'s\'>(.*?)<\/td>.*?<td.*?class=\'s\'>(.*?)<\/td>.*?<td class=\'sl_s\'>(.*?)<\/td>.*?<td class=\'sl_p\'>(.*?)<\/td>.*?<td class=\'s\'>(.*?)<\/td>/s';
        const TORRENT_PARAMS_REGEXP = '/<td class=\"nam\"><a href=\"\/details\.php\?id=([0-9]+)\" class=\"(.*?)\">(.*?)<\/a><td class=\'s\'>.*?<\/td>.*?<td.*?class=\'s\'>(.*?)<\/td>(.*?)<td class=\'sl_s\'>(.*?)<\/td>.*?<td class=\'sl_p\'>(.*?)<\/td>.*?<td class=\'s\'>(.*?)<\/td>/s';
        
        // ,   kinozal.tv 
        //       
        const CATEGORIES_REGEXP = '/<select name="c" class=w190>(.*?)<\/select>/s';
        //    id    
        const CATEGORY_ID_NAME_REGEXP = '/<option.*?value=([0-9]+).*?>(.*?)<\/option>/s';
        //     
        const SILVER_CLASS = 'r2';
        //    
        const SILVER_LABEL = ' /  ';
        //     
        const GOLD_CLASS = 'r1';
        //    
        const GOLD_LABEL = ' /  ';
        //    
        const MB_REGEXP = '/(.*)/siU';
        //    
        const MB_BYTES = 1048576;
        //    
        const GB_REGEXP = '/(.*)/siU';
        //    
        const GB_BYTES = 1073741824;
        // -
        const DATE_TODAY = '//';
        const DATE_YESTERDAY = '//';
        //    dd.mm.yyy  yyyy-dd-mm
        const DATE_REVERSE_REGEXP_FIND = '/(\d\d)\.(\d\d).(\d\d\d\d)/';
        const DATE_REVERSE_REGEXP_CHANGE = '$3-$2-$1';
        private $debug  = 0;

        
        private function DebugLog($str) {
                if ($this->debug==1) {
                        file_put_contents('/tmp/ng_kinozal.log',$str,FILE_APPEND);
                }
        }
        
        // 1    ,   (http://download.synology.com/download/ds/userguide/DLM_Guide.pdf) 
        public function prepare($curl, $query) 
        {                                                  
                //     
                $query = urlencode(iconv("UTF-8","cp1251",$query));
                curl_setopt($curl, CURLOPT_URL, self::PROXY_URL.sprintf(self::QUERY_URL,$query));
        }

        // 2    ,   html-   
        public function parse($plugin, $response) 
        {
                //     
                $response = iconv("cp1251","UTF-8",$response);
                $silver_label_utf8 = iconv("cp1251","UTF-8",self::SILVER_LABEL);
                $gold_label_utf8 = iconv("cp1251","UTF-8",self::GOLD_LABEL);
                $mb_regexp_utf8 = iconv("cp1251","UTF-8",self::MB_REGEXP);                                          
                $gb_regexp_utf8 = iconv("cp1251","UTF-8",self::GB_REGEXP);
                $today_regexp_utf8 = iconv("cp1251","UTF-8",self::DATE_TODAY);
                $yesterday_regexp_utf8 = iconv("cp1251","UTF-8",self::DATE_YESTERDAY);

                //          
                //    kinozal.tv, ..    
                
                $categories_array=array();
                
                if (preg_match(self::CATEGORIES_REGEXP, $response, $categories_match)) 
                {
                        
                        preg_match_all(self::CATEGORY_ID_NAME_REGEXP,$categories_match[0],$category_matches,PREG_SET_ORDER);
                        foreach ($category_matches as $category_match) 
                        {
                                $i=$category_match[1];
                                $categories_array[$i]=$category_match[2];
                        }
                }
              
                $result=0;          

                //     ,     (,   .
                $count = preg_match_all(self::TORRENTS_REGEXP, $response, $torrent_matches, PREG_SET_ORDER); 

                $this->DebugLog("$count");

                foreach ($torrent_matches as $torrent_match) 
                {
                        $title = "";
                        $download = "";
                        $size = 0;
                        $datetime = "";
                        $page = "";
                        $hash = "";
                        $seeds = 0; 
                        $leechs = 0;
                        
                        $i = $torrent_match[1];
                        $category = $categories_array[$i];  
                        
                        if (preg_match(self::TORRENT_PARAMS_REGEXP, $torrent_match[2], $params_match)) 
                        {
                                //     / ( kinozal.tv)
                                
                                $title = $params_match[3];
                                if ($params_match[2]==self::SILVER_CLASS)
                                {
                                        $title = $title.$silver_label_utf8; 
                                }
                                if ($params_match[2]==self::GOLD_CLASS)
                                {
                                        $title = $title.$gold_label_utf8;
                                }                                            
                                $title = strip_tags($title);
                 
                                $download = self::PROXY_URL.sprintf(self::TORRENT_URL,$params_match[1]);

                                //           ( kinozal.tv)
                                $size = strip_tags($params_match[4]);
                                
                                if (preg_match($mb_regexp_utf8,$size,$mb_match))
                                {                               
                                        $size = $mb_match[1]*self::MB_BYTES; 
                                }
                                if (preg_match($gb_regexp_utf8,$size,$gb_match))
                                {
                                        $size = $gb_match[1]*self::GB_BYTES; 
                                }

                                $datetime = strip_tags($params_match[8]);
                                if (preg_match($today_regexp_utf8,$datetime))
                                {
                                        $datetime = preg_replace($today_regexp_utf8, date('Y-m-d', strtotime('today')), $datetime);
                                
                                }
                                if (preg_match($yesterday_regexp_utf8,$datetime))
                                {
                                        $datetime = preg_replace($yesterday_regexp_utf8, date('Y-m-d', strtotime('yesterday')), $datetime);
                                }
                                $datetime = preg_replace(self::DATE_REVERSE_REGEXP_FIND,self::DATE_REVERSE_REGEXP_CHANGE,$datetime);                      
                                
                                
                                
                                $page = sprintf(self::INFO_URL,$params_match[1]);

                                //   
                                $hash = md5(self::INFO_URL.$result.$title);

                                $seeds = strip_tags($params_match[6]);
                                $leechs = strip_tags($params_match[7]);
                        }else{
                                $this->DebugLog(" no TORRENT_PARAMS_REGEXP");
                        }
                                
                        
                        if ($title != "") //  ,    
                        {
                                //  Download Station
                                $plugin->addResult($title, $download, $size, $datetime, $page, $hash, $seeds, $leechs, $category);
                                $result++;
                        }
                }
                //                      
                return $result;
        }
}
?>